#!/usr/bin/python

"""Give the URI of the icon.
This script caches the image in user's preference directory and returns the local URI.
"""
import os, sys
global __flag_PIL
try:
    raise Exception( "not available" )
    import Image
    __flag_PIL = True
except:
    __flag_PIL = False
    pass


def __get_home():
    import tempfile, re
    file_temp = tempfile.mktemp()
    env = os.system( "/usr/bin/env > %s" % file_temp )
    path_home = "~/"
    for line in open( file_temp ).readlines():
        m = re.match( "HOME\\s*=\\s*(.+)", line.strip() )
        if m:
            path_home = m.group( 1 )
            break
        pass
    os.unlink( file_temp )
    return path_home

#ninitialization
global __dir_home
__dir_home = __get_home()

import os.path
if os.path.exists( __dir_home + '/Library/DashStick/Logo' ) and \
   os.path.exists( __dir_home + '/Library/DashSTicker/Logo' ) == False:
    os.rename( __dir_home + '/Library/DashStick/Logo', __dir_home + '/Library/DashSTicker/Logo' )
    pass

def getURI( url, category, name = None, dir_home = None, transparency = ( 0, 0 ) ):
    """ Returns local URI of an icon with sports category, name of the icon,
    directory and whether the background is changed transparent or not.
     If the original icon has transparent background, set the argument 'transparency'
     as None.
    """
    if name is None:
        name = ((url.split( '/' ))[ -1 ].split( "." ))[ 0 ]
        pass
    if dir_home == None: dir_home = __dir_home #__get_home()
    dirname = "%s/Library/DashSTicker/Logo/%s" % ( dir_home, category )
    ext_output = "png"
    if __flag_PIL == False or transparency == None:
        ext_output = url.split( '.' )[ -1 ]
        pass
    filename = "%s/%s.%s" % ( dirname, name, ext_output )
    uri = "file://" + filename
    if os.path.exists( filename ):
        return uri
    
    import tempfile
    ext = '.gif'
    if len( url.split( "." ) ) > 1: ext = "." + url.split( "." )[ -1 ]
    filename_tmp = tempfile.mktemp( ext )
    os.system( "/usr/bin/curl %s -o %s -s" % ( url, filename_tmp ) )
    if os.path.exists( filename_tmp ) == False:
        raise Exception( "cannot load" )
    
    os.system( "mkdir -p %s" % dirname )
    if __flag_PIL == True and transparency != None:
        try:
            import Image
            im = Image.open( filename_tmp )
            if transparency != None:
                im.save( filename, transparency=im.getpixel( transparency ) )
            else:
                im.save( filename )
                pass
            os.unlink( filename_tmp )
            pass
        except ImportError:
            os.rename( filename_tmp, filename )
            pass
        except:
            raise
        pass
    else:
        os.rename( filename_tmp, filename )
        pass
    return uri

if __name__ == "__main__":
    if len( sys.argv ) < 3: sys.exit()
    url = sys.argv[ 1 ]
    category = sys.argv[ 2 ]
    if len( sys.argv ) > 3:
        name = sys.argv[ 3 ]
    else:
        name = None
        pass
    if len( sys.argv ) > 4:
        dir_home = sys.argv[ 4 ]
    else:
        dir_home = None
        pass
    print getURI( url, category, name, dir_home = dir_home )
