#!/usr/bin/python
# -*- coding:utf-8 -*-

"""An abstract class of scoreboard classes.
"""

from dom import *
import scorecard
import makelogo

def newInstance():
    return None
    return MLS_MLSNet_2005()


class MLS_MLSNet_2005 ( scorecard.ScoreCard ):
    def __init__( self ):
        scorecard.ScoreCard.__init__( self )
        return

    """Overridable methods"""
    
    def getSportsCategory( self ):
        return "soccer"

    def getCountry( self ):
        return "USA"

    def getName( self ):
        return "MLS (mlsnet.com)"

    def getVersion( self ):
        return "1.0"

    def getIcon( self, team ):        
        """URI (local resource is recommended, see makelogo.py) of
        a team logo.
        This method returns empty string (not None) if no URI are
        found."""
        return ""

    def getEncoding( self ):
        return 'latin1'

    def getLanguage( self ):
        return "en"

    def getURL( self ):
        return "http://www.mlsnet.com/MLS/scoreboard/"

    def interpreteDocument( self, document ):
        #print document
        elem = document.get_element_at_path( '/html/table/tr' )
        while elem:
            #print elem
            #print elem.get_text( ',' )
            elem_game = elem.get_element_at_path( 'td/table' )
            if elem_game == None:
                print elem.get_text( '/' )
                pass
            while elem_game:
                #print elem_game
                for child in elem_game.get_children():
                    if isinstance( child, Element ):
                        print child.get_text( ',' )
                        pass
                    pass
                try:
                    elem_game = elem_game.next_sibling( 'table' )
                except:
                    break
                pass
            
                
            try:
                elem = elem.next_sibling( 'tr' )
            except:
                break
            pass
        import sys
        sys.exit()
        """Interpreting information. This method must be overridden."""
        raise TypeError( "not implemented" )

    def getIgnorableTags( self ):
        return []

    def getStartKeyword( self ):
        return "<!-- get /components/schedule/main.jsp -->"
        """For shortcutting HTML parsing, this method gives the
        keyword of start position of information.
        This method returns None when any keyword is required.
        """
        return None

    def getEndKeyword( self ):
        return "<div id=\"footer\">"
        """For shortcutting HTML parsing, this method gives the
        keyword of end position of information.
        This method returns None when any keyword is required."""
        return None

    def toHTML( self ):
        """Format data into HTML.
        This method must be overridden."""
        html  = self.html_header()
        if len( self.tables ) == 0:
            html += self.html_footer()
            return html
        for table in self.tables:
            try:
                title = table[ 'title' ]
                rows = table[ 'data' ]
                html += '<span class="tabletitle">%s</span>\n' % title
                html += '<table>\n'
                for row in rows:
                    html += '<tr>'
                    for i in range( min( len( self.headerclasses ), len( row ) ) ):
                        html += '<td class="%s">%s</td>' % ( self.headerclasses[ i ], row[ i ] )
                        pass
                    html += '</tr>\n'
                    pass
                html += '</table>\n'
            except:
                pass
            pass
        html += self.html_footer()
        return html

    def html_css_plugin( self ):
        """This method is overidable by subclasses which uses stylesheet template and add some features in css."""
        return ""

    pass


if __name__ == "__main__":
    
    import sys
    import tempfile
    from dom import *

    skin = None
    filename_input = None

    obj = newInstance()
    if len( sys.argv ) > 1: filename_input = sys.argv[ 1 ]
    
    if obj == None or obj.isAvailable() == False:
        print "invalid object"
        sys.exit()

    url = obj.getURL()
    encoding = obj.getEncoding()
    if filename_input:
        data = ""
        for line in open( filename_input ).readlines():
            data += line
            pass
        pass
    else:
        import loader
        data = loader.loadHTML( url, encoding )
        pass
    kw_start = obj.getStartKeyword()
    kw_end   = obj.getEndKeyword()
    parser = DOMConverter()
    for tag in obj.getIgnorableTags():
        parser.add_ignoring_tag( tag )
        pass
    if kw_start == None or kw_end == None:
        if encoding == None:
            parser.feed( obj.decode( obj.applyFilter( data ) ) )
        else:
            for line in data.split( "\n" ):
                parser.feed( obj.applyFilter( line ) )
                pass
            pass
        pass
    else:
        flag_inside = False
        parser.feed( '<html>' )
        for line in re.split( "\n", data ):
            line = obj.applyFilter( line )
            if encoding == None:
                line = obj.decode( line.strip() )
                pass
            if flag_inside:
                if line.count( kw_end ) > 0:
                    flag_inside = False
                    break
                else:
                    parser.feed( line )
                    pass
            elif line.count( kw_start ) > 0: flag_inside = True
            pass
        parser.feed( '</html>' )
        pass
    document = parser.get_document()
    obj.interpreteDocument( document )
    contents = obj.toHTML()
    print contents
