#!/usr/bin/python
# -*- coding:utf-8 -*-

from dom import *
import scorecard
#import makelogo

def newInstance():
    return PGAGolf_Yahoo_2005()

class PGAGolf_Yahoo_2005( scorecard.ScoreCard ):
    def __init__( self ):
        scorecard.ScoreCard.__init__( self )
        self.title = ""
        self.scores = []
        return
        
    def getName( self ):
        return "PGA (yahoo.com)"

    def getVersion( self ):
        return "1.0"

    def getSportsCategory( self ):
        return "Golf"

    def getCountry( self ):
        return "USA"

    def getURL( self ):
        return "http://sports.yahoo.com/golf"

    def decode( self, contents ):
        return contents
    
    def getEncoding( self ):
        return 'latin1'

    def getStartKeyword( self ):
        return 'PGA Leaderboard'

    def getEndKeyword( self ):
        return "Full Leaderboard"

        

    def interpreteDocument( self, document ):
        import sys, re
        #print document
        try:
            elem_title = document.get_element_at_path( "/html/table/tr/td/table/tr/td/spacer/tr/td" )
            self.title = elem_title.get_text()
            elem_player = document.get_element_at_path( "/html/table/tr/td/table/tr/td/spacer/tr/td/spacer/tr/td/table/tbody/tr" )
            self.scores = []
            while elem_player != None:
                items = elem_player.get_text( '*,*' ).split( '*,*' )
                if len( items ) >= 2 and items[ 0 ] != '':
                    self.scores.append( items )
                    pass
                try:
                    elem_player = elem_player.next_sibling()
                except:
                    break
                pass
            pass
        except:
            raise
        return

        
        elem_date = document.get_element_at_path( "/html/table/tr,3/td/table/tr/td,3" )
        elem_date = document.get_element_at_path( "/html/table/tr,3/td/table/tr/td" )
        import re, sys
        while elem_date != None:
            text = elem_date.get_text( " " )
            if re.search( "\\d+/\\d+/\\d+", text ):
                self.date = text
                break
            try:
                elem_date = elem_date.next_sibling( 'td' )
            except:
                break
            pass

        elem = document.get_element_at_path( "/html/div/table/tr/td" )
        e = elem.get_element_at_path( 'table' )
        while e != None:
            gamestatus = self.resolve_game( e )
            if gamestatus != None:
                self.games.append( gamestatus )
                pass
            try:
                e = e.next_sibling( 'table' )
            except:
                break
            pass
        return

    def toHTML( self ):
        import re
        html = self.html_header()
        title = self.title + " " + self.getName()
        html += "<body>"
        title = re.sub( "\([^\)]*\)$", "", title )
        if len( self.scores ) > 0:
            html += '<span class="tabletitle">%s</span>' % title
            html += "<table>"
            for player in self.scores:
                if len( player ) == 2: # not started
                    html += '<tr><td class="player">%s</td"><td class="score"></td><td class="status">%s</td></tr>\n' % ( player[ 0 ], player[ 1 ] )
                elif len( player ) > 3:
                    html += '<tr><td class="rank">%s</td><td class="player">%s</td"><td class="score">%s</td><td class="status">%s</td></tr>\n' % ( player[ 0 ], player[ 1 ], player[ 3 ], player[ 2 ] )
                    
                pass
            html += "</table>"
            pass
        html += "</body>"
        html += self.html_footer()
        return html        

    def html_css( self ):
        return """
        <style type=\"text/css\">
        body {margin:0px;padding:0px;overflow:hidden;}
        table {margin:0px;align:center;}
        .tabletitle { border-left:#800 4px solid; padding:2px 8px 2px 8px; font-family: \"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size: 11px; font-weight: bold; color:white; margin-bottom:5px; background:gray;}
        .player { color:black; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; font-weight:bold; width:150px; height:20px;text-align:center;}
        .teamlogo { width:24px; margin:0px;padding:0px;}
        .score { color:#003; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; width:40px; height:20px;text-align:center;margin:0px;}
        .rank { color:gray; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; width:20px; height:20px;font-weight:bold; text-align:right;margin:0px;padding:0px;}
        .status { color:gray; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; width:40px; height:20px;font-weight:bold; text-align:right;margin:0px;padding:0px;}
        </style>
        """
    pass

if __name__ == "__main__":
    from loader import *
    obj = newInstance()

    if obj != None and obj.isAvailable():
        url = obj.getURL()
        data = loadHTML( url )
        
        #data = loadHTML_test( "../../html/golf_yahoo_com2.html" )
        kw_start = obj.getStartKeyword()
        kw_end   = obj.getEndKeyword()
        parser = DOMConverter()
        if kw_start == None or kw_end == None:
            parser.feed( obj.decode( data ) )
            pass
        else:
            flag_inside = False
            parser.feed( '<html>' )
            for line in re.split( "\n", data ):
                line = obj.decode( line.strip() )
                if flag_inside:
                    if line.count( kw_end ) > 0: flag_inside = False
                    else: parser.feed( line )
                elif line.count( kw_start ) > 0: flag_inside = True
                pass
            parser.feed( '</html>' )
            pass
        document = parser.get_document()
        obj.interpreteDocument( document )
        print obj.toHTML()
        #file_out = open( filename_output, "w" )
        #file_out.write( obj.toHTML() )
        #file_out.close()
        #uri = "file://%s" % filename_output
        #print uri
        pass
    pass


#data = unicode( open( "../html/j1.html" ).readlines().join( "" ), 'sjis' )
    
