#!/usr/bin/python
# -*- coding:utf-8 -*-

__restriction = [ 'loader.py', 'scorecard.py', 'dom.py' ]

def __enumerateFiles():
    import os, os.path
    pyfiles = []
    for ( path, dirs, filenames ) in os.walk( "./" ):
        for filename in filenames:
            if filename[ -3: ] == '.py':
                if __restriction.count( filename ) == 0:
                    pyfiles.append( "%s/%s" % ( path, filename ) )
                    pass
                pass
            pass
        pass
    return pyfiles

def __loadModule( filename ):
    import ihooks, os.path
    loader = ihooks.BasicModuleLoader()
    path, file = os.path.split( filename )
    name, ext = os.path.splitext( file )
    mid = loader.find_module_in_dir( name, path )
    if not mid:
        raise ImportError, name
    return loader.load_module( name, mid )

def __loadModuleByName( path, modulename ):
    import ihooks, os.path
    loader = ihooks.BasicModuleLoader()
    mid = loader.find_module_in_dir( modulename, path )
    if not mid:
        raise ImportError, modulename
    return loader.load_module( modulename, mid )

def loadHTML( url ):
    import tempfile, os, re
    url = re.sub( "\"\';", "", url )    
    filename_tmp = tempfile.mktemp( '.html', 'scorecard' )
    os.system( "/usr/bin/curl \"%s\" -o \"%s\" -s" % ( url, filename_tmp ) )
    data = ""
    for line in open( filename_tmp ).readlines():
        data += line
        pass
    os.unlink( filename_tmp )
    return data

def loadHTML_test( path ):
    data = ""
    if path == None: path = "../html/nabisco.html"
    for line in open( path ).readlines():
        data += line
        pass
    return data
    pass

def getModuleList():
    import scorecard
    import re
    mlist = []
    
    for filename in __enumerateFiles():
        if not re.match( "\\w", filename.split( '/' )[ -1 ] ): continue
        m = __loadModule( filename )
        if not m: continue
        if dir( m ).count( 'newInstance' ) == 0: continue
        obj = None
        try:
            obj = m.newInstance()
        except:
            continue
        if issubclass( obj.__class__, scorecard.ScoreCard ) == False:
            continue
        mlist.append( ( m, m.__name__, obj.getName(), obj.getSportsCategory() ) )
        pass
    return mlist

def __output_error( filename ):
    return

if __name__ == "__main__":
    
    import sys
    import tempfile
    import scorecard
    from dom import *

    if len( sys.argv ) < 2:
        ms = getModuleList()
        ms.sort( lambda x, y: 0 - ( x[ 2 ] < y[ 2 ]  ) )
        for m in ms:
            print "\"%s\",\"%s\",\"%s\"" % ( m[ 1 ], m[ 2 ], m[ 3 ] )
            pass
        sys.exit()
        pass
    filename_output = None
    module_name = sys.argv[ 1 ]
    if len( sys.argv ) < 3:
        filename_output = tempfile.mktemp( ".html", "dashstick" )
    else:
        filename_module = sys.argv[ 2 ]
        sp = filename_module.split( "/" )
        if sp[ -1 ] == "":
            raise Exception()
            sys.exit()
        else:
            fn = sp[ -1 ]
            if fn[ -5 : ] != ".html":
                fn += ".html"
                pass
            filename_output = tempfile.gettempdir() + "/" + fn
            pass
        pass

    ms = getModuleList()
    module = None
    for m in ms:
        if m[ 1 ] == module_name:
            module = m[ 0 ]
            break
        pass
    if module == None:
        __output_error( filename_output )
        raise Exception()
        sys.exit()
        pass
    obj = module.newInstance()

    if obj != None and obj.isAvailable():
        url = obj.getURL()
        data = loadHTML( url )
        #data = loadHTML_test( "../html/yb.html" )
        #data = unicode( loadHTML( url ), obj.getEncoding() ).encode( 'utf-8' )
        #data = unicode( loadHTML_test( url ), obj.getEncoding() ).encode( 'utf-8' )
        kw_start = obj.getStartKeyword()
        kw_end   = obj.getEndKeyword()
        parser = DOMConverter()
        if kw_start == None or kw_end == None:
            parser.feed( obj.decode( data ) )
            pass
        else:
            flag_inside = False
            parser.feed( '<html>' )
            for line in re.split( "\n", data ):
                line = obj.decode( line.strip() )
                #print line
                if flag_inside:
                    if line.count( kw_end ) > 0:# == kw_end:
                        #print "###############"
                        flag_inside = False
                        break
                    else: parser.feed( line )
                elif line.count( kw_start ) > 0:flag_inside = True #line == kw_start: flag_inside = True
                pass
            parser.feed( '</html>' )
            pass
        document = parser.get_document()
        obj.interpreteDocument( document )
        file_out = open( filename_output, "w" )
        file_out.write( obj.toHTML() )
        file_out.close()
        uri = "file://%s" % filename_output
        print uri
        pass
    pass

