#!/usr/bin/python

import os, sys
import Image

def __get_home():
    import tempfile, re
    file_temp = tempfile.mktemp()
    env = os.system( "/usr/bin/env > %s" % file_temp )
    path_home = "~/"
    for line in open( file_temp ).readlines():
        m = re.match( "HOME\\s*=\\s*(.+)", line.strip() )
        if m:
            path_home = m.group( 1 )
            break
        pass
    os.unlink( file_temp )
    return path_home

def getURI( url, category, name = None, dir_home = None, transparency = ( 0, 0 ) ):
    if name is None:
        name = ((url.split( '/' ))[ -1 ].split( "." ))[ 0 ]
        pass
    if dir_home == None: dir_home = __get_home()
    dirname = "%s/Library/DashStick/Logo/%s" % ( dir_home, category )
    filename = "%s/%s.png" % ( dirname, name )
    uri = "file://" + filename
    if os.path.exists( filename ):
        return uri
    
    import tempfile
    ext = '.gif'
    if len( url.split( "." ) ) > 1: ext = "." + url.split( "." )[ -1 ]
    filename_tmp = tempfile.mktemp( ext )
    os.system( "/usr/bin/curl %s -o %s -s" % ( url, filename_tmp ) )
    if os.path.exists( filename_tmp ) == False:
        raise Exception( "cannot load" )
    
    os.system( "mkdir -p %s" % dirname )
    im = Image.open( filename_tmp )
    if transparency != None:
        im.save( filename, transparency=im.getpixel( transparency ) )
    else:
        im.save( filename )
        pass
    os.unlink( filename_tmp )
    return uri

if __name__ == "__main__":
    if len( sys.argv ) < 3: sys.exit()
    url = sys.argv[ 1 ]
    category = sys.argv[ 2 ]
    if len( sys.argv ) > 3:
        name = sys.argv[ 3 ]
    else:
        name = None
        pass
    if len( sys.argv ) > 4:
        dir_home = sys.argv[ 4 ]
    else:
        dir_home = None
        pass
    print getURI( url, category, name, dir_home = dir_home )
