#!/usr/bin/python
# -*- coding:utf-8 -*-

"""test module"""

from dom import *

# def getInstance():
#     #print "retrieving result"
#     return ScoreCard()
#     pass


class ScoreCard:
    def __init__( self ):
        return
    
    def writeHTML( self, filename ):
        file = open( filename, "w" )
        file.write( self, toHTML() )
        file.close()
        pass
        
    def getName( self ):
        return None

    def getVersion( self ):
        return "0.0"

    def getSportsCategory( self ):
        raise TypeError( "not implemented" )

    def getCountry( self ):
        raise TypeError( "not implemented" )

    def isAvailable( self ):
        try:
            self.getURL()
            self.getSportsCategory()
        except:
            return False
        if self.getName() == None: return False
        return True

    def decode( self, contents ):
        return unicode( contents, self.getEncoding() ).encode( 'utf-8' )
        
    def getURL( self ):
        raise TypeError( "not implemented" )

    def interpreteDocument( self, document ):
        raise TypeError( "not implemented" )

    def getStartKeyword( self ):
        return None

    def getEndKeyword( self ):
        return None

    def getEncoding( self ):
        return 'sjis'

    def getLanguage( self ):
        return "ja"

    def toHTML( self ):
        return "<html></html>"

    def xml_lang( self ):
        return "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"%s\" lang=\"%s\">" % ( self.getLanguage() , self.getLanguage() )

    def xml_header( self ):
        return "<?xml version=\"1.0\" encoding=\"utf-8\"?>"

    def xml_doctype( self ):
        return "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">"
        
    def html_header( self ):
        html =  self.xml_header()
        html += self.xml_doctype()
        html += self.xml_lang()
        html += "<head><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta http-equiv=\"Content-Script-Type\" content=\"text/javascript\"/>"
        html += "<title>%s</title>" % ( self.getName() )
        html += self.html_css()
        html += "</head>"
        return html

    def html_css( self ):
        return """
        <style type=\"text/css\">
        body {margin:0px;padding:0px;overflow:hidden;}
        table {margin:0px;align:center;}
        #tabletitle { border-left:#800 4px solid; padding:2px 8px 2px 8px; font-family: \"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size: 11px; font-weight: bold; color:white; margin-bottom:5px; background:gray;}
        .team { color:black; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; font-weight:bold; width:60px; height:24px;text-align:center;}
        .teamlogo { width:24px; margin:0px;padding:0px;}
        .score { color:#003; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; width:40px; height:24px;text-align:center;margin:0px;}
        .status { color:gray; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; width:40px; height:24px;font-weight:bold; text-align:right;margin:0px;padding:0px;}
        .place { color:gray; font-family:\"HiraMaru-Pro\" \"Lucida Grande\" serif; font-size:10px; width:40px; height:24px;font-weight:bold; text-align:right;margin:0px;padding:0px;}
        .logo { width:24px; height:24px; margin:0px 2px 0px 2px;padding:0px;}
        </style>
        """


    def html_footer( self ):
        return '</html>'

    pass

